<?php

namespace Drupal\ajax_debug\EventSubscriber;

use Drupal\Core\Ajax\AjaxResponse;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\FilterResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;

/**
 * Class KernelEventSubscriber
 *
 * @package Drupal\symfony_debug\EventSubscriber
 */
class ResponseSubscriber implements EventSubscriberInterface {

  public function onResponse(FilterResponseEvent $event) {
    $response = $event->getResponse();
    if ($response instanceof AjaxResponse) {
      // We undo what AjaxResponseSubscriber does.
      $response->headers->set('Content-Type', 'application/json; charset=utf-8');
      $response->setContent(
        rtrim(
          ltrim(
            $response->getContent(),
            '<textarea>'
          ),
          '</textarea>'
        )
      );
    }
  }

  /**
   * @return array
   */
  public static function getSubscribedEvents() {
    return [
      // Just after AjaxResponseSubscriber.
      KernelEvents::RESPONSE => ['onResponse', -101],
    ];
  }

}
